#!/usr/local/bin/tcl

set Port "/dev/ttyS0"
set Baud "9600"
set Bits "8"
set Stop "1"
set Party "n"

#
# test commandline args
if { $argc < 1 } {
   puts stderr "usage:  $argv0 FileNameToHoldRawAltAccData"
   exit 1
}
#
# get the OutPutFile
set OutFile [lindex $argv 0]

#
# open the AltAcc
set AltAccHandle [open $Port "RDWR"]

#
# set the Serial Parms
fconfigure $AltAccHandle -mode $Baud,$Party,$Bits,$Stop \
                         -buffering "none" \
                         -translation "binary"
#
# send a /R and grab the data
puts -nonewline $AltAccHandle "/R"
flush $AltAccHandle
set AltAccData [read $AltAccHandle 8196]
close $AltAccHandle

#
# Open OutFile and write the results
set OutFileHandle [open $OutFile "w"]
puts -nonewline $OutFileHandle $AltAccData
close $OutFileHandle

exit 0
