#!/usr/local/bin/tcl

proc ErrHandler { } {

   puts stderr "Caught an Error!"

   return

} 

set Port "/dev/ttyS0"
set Baud "9600"
set Bits "8"
set Stop "1"
set Party "n"

set LCount 0

set AMin  256
set AMax  0

set PMin  256
set PMax  0

set BASum 0.0000
set BPSum 0.0000
set Loops 0

# catch ErrHandler
#
# open the AltAcc
set AltAccHandle [open $Port "RDWR"]

#
# set the Serial Parms
fconfigure $AltAccHandle -mode $Baud,$Party,$Bits,$Stop \
                         -buffering "none" \
                         -translation "binary"
while { 1 == 1 } {

#
# set up to read, sum and print
set Count 0
set ASum  0.0
set PSum  0.0
set Tries 0

#
# send a /T and grab the data

puts -nonewline $AltAccHandle "/T"
flush $AltAccHandle

while { $Count < 256 } {

   set ALine [gets $AltAccHandle]
   set AList [split $ALine]

   set A [string trimleft [lindex $AList 0] 0OK]
   set P [string trimleft [lindex $AList 1] 0OK]

   if { $A < $AMin } {
      set AMin $A
   }
   if { $A > $AMax } {
      set AMax $A
   }

   if { $P < $PMin } {
      set PMin $P
   }
   if { $P > $PMax } {
      set PMax $P
   }

   set ASum [expr $ASum + $A]
   set PSum [expr $PSum + $P]

   set OutStr [format "%8.4f  %8.4f  %10.4f  %10.4f\r" $A $P $ASum $PSum]
   puts -nonewline stderr $OutStr

   incr Count
}

set AAvg [expr $ASum / $Count]
set PAvg [expr $PSum / $Count]

set BASum [expr $BASum + $ASum]
set BPSum [expr $BPSum + $PSum]

set Loops [expr $Loops + 256]

set BA [expr $BASum / $Loops]
set BP [expr $BPSum / $Loops]

incr LCount

set OutStr [format "\n%8.4f  %8.4f  %10.4f  %10.4f   %3d  %3d  %3d  %3d  %d\n" \
                       $AAvg $PAvg $BA $BP $AMin $AMax $PMin $PMax $LCount ]

puts -nonewline stderr $OutStr

set Delay 1
puts -nonewline stderr "waiting $Delay sec"
for { set i 0 } { $i < $Delay } { incr i } {
   puts -nonewline stderr "."
   after 1000
}

puts stderr ""

}

close $AltAccHandle

exit 0
